// Generated by CoffeeScript 1.4.0
var Button, ButtonGroup, ButtonToolbar, DatePicker, DateTime, DropdownButton, Glyphicon, Input, MenuItem, MonthPicker, PickerMixin, PropTypes, Table, TimePicker, YearPicker, createClass, createElement, defaultFormat, div, formatRegex, moment, table, tbody, td, th, thead, tr, _ref, _ref1, _ref2;

_ref = require("react"), createClass = _ref.createClass, createElement = _ref.createElement, (_ref1 = _ref.DOM, div = _ref1.div, table = _ref1.table, thead = _ref1.thead, tbody = _ref1.tbody, th = _ref1.th, tr = _ref1.tr, td = _ref1.td), PropTypes = _ref.PropTypes;

_ref2 = require("react-bootstrap"), Input = _ref2.Input, ButtonToolbar = _ref2.ButtonToolbar, ButtonGroup = _ref2.ButtonGroup, Button = _ref2.Button, DropdownButton = _ref2.DropdownButton, MenuItem = _ref2.MenuItem, Table = _ref2.Table, Glyphicon = _ref2.Glyphicon;

moment = require("moment");

defaultFormat = moment.defaultFormat;

formatRegex = /([QeEAaXx]|M{1,4}o?|D{1,4}o?|d{1,4}o?|w{1,2}o?|W{1,2}o?|Y{2,4}|g{2,4}|G{2,4}|H{1,2}|h{1,2}|m{1,2}|s{1,2}|S{1,3}|z{1,2}|Z{1,2})/;

PickerMixin = {
  getDefaultProps: function() {
    var defaultValue, format;
    format = defaultFormat;
    defaultValue = (moment()).format(format);
    return {
      format: format,
      defaultValue: defaultValue
    };
  },
  getInitialState: function() {
    var defaultValue, value, _ref3;
    _ref3 = this.props, value = _ref3.value, defaultValue = _ref3.defaultValue;
    if (value == null) {
      value = defaultValue;
    }
    return {
      value: value
    };
  },
  componentWillReceiveProps: function(_arg) {
    var value;
    value = _arg.value;
    return this.setState({
      value: value
    } || (value != null));
  },
  changeValue: function(fn) {
    var date, format, onChange, value, _ref3;
    _ref3 = this.props, format = _ref3.format, onChange = _ref3.onChange;
    value = this.state.value;
    date = moment(value, format);
    fn.call(date);
    value = date.format(format);
    return this.setState({
      value: value
    }, onChange);
  },
  parseFormat: function(format) {
    return format.split(formatRegex);
  },
  moment: function() {
    var format, value;
    format = this.props.format;
    value = this.state.value;
    return moment(value, format);
  },
  getValue: function() {
    return this.state.value;
  },
  tune: function(e, p, n) {
    var delta;
    if (n == null) {
      n = 1;
    }
    e.preventDefault();
    delta = e.deltaY || e.deltaX;
    delta /= -Math.abs(delta);
    delta *= n;
    return this.changeValue(function() {
      return this.add(delta, p);
    });
  }
};

YearPicker = createClass({
  mixins: [PickerMixin],
  getDefaultProps: function() {
    return {
      yearsRange: [-12, 12]
    };
  },
  getInitialState: function() {
    return {
      yearsOffset: 0
    };
  },
  pageYears: function(page) {
    var yearsOffset, yearsRange;
    yearsRange = this.props.yearsRange;
    yearsOffset = this.state.yearsOffset;
    yearsOffset += page * (yearsRange[1] - yearsRange[0]);
    return this.setState({
      yearsOffset: yearsOffset
    });
  },
  prevYears: function() {
    return this.pageYears(-1);
  },
  nextYears: function() {
    return this.pageYears(1);
  },
  pickYear: function(year) {
    var _this = this;
    return function() {
      _this.changeValue(function() {
        return this.year(year);
      });
      return _this.setState({
        view: "days"
      });
    };
  },
  render: function() {
    var activeYear, baseYear, col, cols, datetime, firstYear, lastYear, row, rows, year, years, yearsOffset, yearsRange;
    datetime = this.moment();
    yearsRange = this.props.yearsRange;
    yearsOffset = this.state.yearsOffset;
    activeYear = datetime.year();
    baseYear = activeYear + yearsOffset;
    firstYear = yearsRange[0] + baseYear;
    lastYear = yearsRange[1] + baseYear;
    years = yearsRange[1] - yearsRange[0] + 1;
    cols = Math.ceil(Math.sqrt(years));
    rows = Math.ceil(years / cols);
    return table(null, thead(null, tr(null, th({
      colSpan: cols - 1
    }, createElement(Button, {
      bsStyle: "link",
      onClick: this.prevYears
    }, createElement(Glyphicon, {
      glyph: "chevron-left"
    }))), th({
      className: "pull-right"
    }, createElement(Button, {
      bsStyle: "link",
      onClick: this.nextYears
    }, createElement(Glyphicon, {
      glyph: "chevron-right"
    }))))), tbody(null, (function() {
      var _i, _results;
      _results = [];
      for (row = _i = 0; 0 <= rows ? _i < rows : _i > rows; row = 0 <= rows ? ++_i : --_i) {
        _results.push(tr({
          key: row
        }, (function() {
          var _j, _results1;
          _results1 = [];
          for (col = _j = 0; 0 <= cols ? _j < cols : _j > cols; col = 0 <= cols ? ++_j : --_j) {
            year = firstYear + row * cols + col;
            _results1.push(td({
              key: col
            }, year <= lastYear ? createElement(Button, {
              bsStyle: year === activeYear ? "primary" : "link",
              onClick: this.pickYear(year)
            }, year) : void 0));
          }
          return _results1;
        }).call(this)));
      }
      return _results;
    }).call(this)));
  }
});

MonthPicker = createClass({
  mixins: [PickerMixin],
  pickMon: function(mon) {
    var _this = this;
    return function() {
      return _this.changeValue(function() {
        return this.month(mon);
      });
    };
  },
  render: function() {
    var activeMonth, col, cols, datetime, month, row, rows;
    datetime = this.moment();
    activeMonth = datetime.month();
    cols = 3;
    rows = 4;
    return table(null, tbody(null, (function() {
      var _i, _results;
      _results = [];
      for (row = _i = 0; 0 <= rows ? _i < rows : _i > rows; row = 0 <= rows ? ++_i : --_i) {
        _results.push(tr({
          key: row
        }, (function() {
          var _j, _results1;
          _results1 = [];
          for (col = _j = 0; 0 <= cols ? _j < cols : _j > cols; col = 0 <= cols ? ++_j : --_j) {
            month = row * cols + col;
            _results1.push(td({
              key: col
            }, createElement(Button, {
              bsStyle: month === activeMonth ? "primary" : "link",
              onClick: this.pickMon(month)
            }, (moment(month + 1, "M")).format("MMMM"))));
          }
          return _results1;
        }).call(this)));
      }
      return _results;
    }).call(this)));
  }
});

DatePicker = createClass({
  mixins: [PickerMixin],
  prevMon: function() {
    return this.changeValue(function() {
      return this.subtract(1, "M");
    });
  },
  nextMon: function() {
    return this.changeValue(function() {
      return this.add(1, "M");
    });
  },
  tuneMon: function(e) {
    return this.tune(e, "M", -1);
  },
  tuneYear: function(e) {
    return this.tune(e, "Y", -1);
  },
  pickDate: function(date) {
    var _this = this;
    return function() {
      return _this.changeValue(function() {
        return this.date(date);
      });
    };
  },
  render: function() {
    var activeDate, date, datetime, day, firstDay, firstWeek, lastDay, lastWeek, lastWeekIsFirst, monthDays, onClickMonth, onClickYear, week, _ref3;
    _ref3 = this.props, onClickYear = _ref3.onClickYear, onClickMonth = _ref3.onClickMonth;
    datetime = this.moment();
    activeDate = datetime.date();
    monthDays = datetime.daysInMonth();
    firstWeek = ((datetime.clone()).date(1)).week();
    lastWeek = ((datetime.clone()).date(monthDays)).week();
    lastWeekIsFirst = false;
    if (lastWeek < firstWeek) {
      lastWeekIsFirst = true;
      lastDay = monthDays;
      while (lastWeek < firstWeek) {
        lastWeek = ((datetime.clone()).date(lastDay)).week();
        lastDay -= 1;
      }
      lastWeek += 1;
    }
    firstDay = ((datetime.clone()).date(1)).weekday();
    lastDay = ((datetime.clone()).date(monthDays)).weekday();
    return table({
      key: "days"
    }, thead(null, tr(null, th(null, createElement(Button, {
      bsStyle: "link",
      onClick: this.prevMon
    }, createElement(Glyphicon, {
      glyph: "chevron-left"
    }))), th({
      colSpan: 3,
      style: {
        textAlign: "center"
      }
    }, createElement(Button, {
      bsStyle: "link",
      onWheel: this.tuneYear,
      onClick: onClickYear
    }, datetime.format("YYYY"))), th({
      colSpan: 3,
      style: {
        textAlign: "center"
      }
    }, createElement(Button, {
      bsStyle: "link",
      onWheel: this.tuneMon,
      onClick: onClickMonth
    }, datetime.format("MMMM"))), th(null, createElement(Button, {
      bsStyle: "link",
      onClick: this.nextMon
    }, createElement(Glyphicon, {
      glyph: "chevron-right"
    }))))), tbody(null, tr(null, th(null), (function() {
      var _i, _results;
      _results = [];
      for (day = _i = 0; _i < 7; day = ++_i) {
        _results.push(th({
          key: day,
          style: {
            textAlign: "center"
          }
        }, (moment(day, "e")).format("ddd")));
      }
      return _results;
    })()), (function() {
      var _i, _results;
      _results = [];
      for (week = _i = firstWeek; firstWeek <= lastWeek ? _i <= lastWeek : _i >= lastWeek; week = firstWeek <= lastWeek ? ++_i : --_i) {
        _results.push(tr({
          key: week
        }, th(null, week), (function() {
          var _j, _results1;
          _results1 = [];
          for (day = _j = 0; _j < 7; day = ++_j) {
            date = (week - firstWeek) * 7 + day - firstDay + 1;
            _results1.push(td({
              key: day
            }, (week !== firstWeek || day >= firstDay) && (week !== lastWeek || day <= lastDay) ? createElement(Button, {
              bsStyle: date === activeDate ? "primary" : "link",
              onClick: this.pickDate(date)
            }, date) : void 0));
          }
          return _results1;
        }).call(this)));
      }
      return _results;
    }).call(this)));
  }
});

TimePicker = createClass({
  mixins: [PickerMixin],
  getDefaultProps: function() {
    return {
      display: "HH:mm:ss"
    };
  },
  prevHour: function() {
    return this.changeValue(function() {
      return this.subtract(1, "h");
    });
  },
  nextHour: function() {
    return this.changeValue(function() {
      return this.add(1, "h");
    });
  },
  tuneHour: function(e) {
    return this.tune(e, "h");
  },
  prevMin: function() {
    return this.changeValue(function() {
      return this.subtract(1, "m");
    });
  },
  nextMin: function() {
    return this.changeValue(function() {
      return this.add(1, "m");
    });
  },
  tuneMin: function(e) {
    return this.tune(e, "m");
  },
  prevSec: function() {
    return this.changeValue(function() {
      return this.subtract(1, "s");
    });
  },
  nextSec: function() {
    return this.changeValue(function() {
      return this.add(1, "s");
    });
  },
  tuneSec: function(e) {
    return this.tune(e, "s");
  },
  toggleAPM: function() {
    return this.changeValue(function() {
      if (12 >= this.hour()) {
        return this.add(12, "h");
      } else {
        return this.subtract(12, "h");
      }
    });
  },
  render: function() {
    var datetime, index, token, tokens;
    datetime = this.moment();
    tokens = this.parseFormat(this.props.display);
    return table(null, tbody(null, tr(null, (function() {
      var _i, _len, _results;
      _results = [];
      for (index = _i = 0, _len = tokens.length; _i < _len; index = ++_i) {
        token = tokens[index];
        _results.push(td({
          key: index
        }, (function() {
          switch (false) {
            case !/^[Hh]/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.nextHour
              }, createElement(Glyphicon, {
                glyph: "chevron-up"
              }));
            case !/^m/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.nextMin
              }, createElement(Glyphicon, {
                glyph: "chevron-up"
              }));
            case !/^s/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.nextSec
              }, createElement(Glyphicon, {
                glyph: "chevron-up"
              }));
          }
        }).call(this)));
      }
      return _results;
    }).call(this)), tr(null, (function() {
      var _i, _len, _results;
      _results = [];
      for (index = _i = 0, _len = tokens.length; _i < _len; index = ++_i) {
        token = tokens[index];
        _results.push(td({
          key: index
        }, (function() {
          switch (false) {
            case !/^[Hh]/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onWheel: this.tuneHour
              }, datetime.format(token));
            case !/^m/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onWheel: this.tuneMin
              }, datetime.format(token));
            case !/^s/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onWheel: this.tuneSec
              }, datetime.format(token));
            case !/^[aA]/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.toggleAPM
              }, datetime.format(token));
            default:
              return token;
          }
        }).call(this)));
      }
      return _results;
    }).call(this)), tr(null, (function() {
      var _i, _len, _results;
      _results = [];
      for (index = _i = 0, _len = tokens.length; _i < _len; index = ++_i) {
        token = tokens[index];
        _results.push(td({
          key: index
        }, (function() {
          switch (false) {
            case !/^[Hh]/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.prevHour
              }, createElement(Glyphicon, {
                glyph: "chevron-down"
              }));
            case !/^m/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.prevMin
              }, createElement(Glyphicon, {
                glyph: "chevron-down"
              }));
            case !/^s/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.prevSec
              }, createElement(Glyphicon, {
                glyph: "chevron-down"
              }));
          }
        }).call(this)));
      }
      return _results;
    }).call(this))));
  }
});

DateTime = createClass({
  propTypes: function() {
    return {
      label: PropTypes.string,
      help: PropTypes.string,
      format: PropTypes.string,
      display: PropTypes.string,
      value: PropTypes.string,
      defaultValue: PropTypes.string
    };
  },
  getDefaultProps: function() {
    var datePart, defaultValue, format, timePart;
    format = defaultFormat;
    datePart = "YYYY-MM-DD";
    timePart = "HH:mm:ss";
    defaultValue = (moment()).format(format);
    return {
      format: format,
      datePart: datePart,
      timePart: timePart,
      defaultValue: defaultValue
    };
  },
  getInitialState: function() {
    var defaultValue, value, _ref3;
    _ref3 = this.props, value = _ref3.value, defaultValue = _ref3.defaultValue;
    if (value == null) {
      value = defaultValue;
    }
    return {
      value: value,
      dateView: "days"
    };
  },
  componentWillReceiveProps: function(_arg) {
    var value;
    value = _arg.value;
    if (value != null) {
      return this.setState({
        value: value
      });
    }
  },
  viewDays: function() {
    return this.setState({
      dateView: "days"
    });
  },
  viewYears: function() {
    return this.setState({
      dateView: "years"
    });
  },
  viewMonths: function() {
    return this.setState({
      dateView: "months"
    });
  },
  changeValue: function(field) {
    var onChange, value;
    value = this.refs[field].getValue();
    onChange = this.props.onChange;
    if (onChange != null) {
      return onChange(value);
    } else {
      return this.setState({
        value: value
      });
    }
  },
  handleYear: function() {
    this.changeValue("year");
    return this.viewDays();
  },
  handleMonth: function() {
    this.changeValue("month");
    return this.viewDays();
  },
  handleDay: function() {
    return this.changeValue("day");
  },
  handleTime: function() {
    return this.changeValue("time");
  },
  render: function() {
    var addonAfter, addonBefore, bsStyle, datePart, dateView, datetime, dropup, format, help, label, noCaret, timePart, value, _ref3, _ref4;
    _ref3 = this.props, label = _ref3.label, help = _ref3.help, addonBefore = _ref3.addonBefore, addonAfter = _ref3.addonAfter, format = _ref3.format, datePart = _ref3.datePart, timePart = _ref3.timePart, noCaret = _ref3.noCaret, dropup = _ref3.dropup, bsStyle = _ref3.bsStyle;
    _ref4 = this.state, value = _ref4.value, dateView = _ref4.dateView;
    datetime = moment(value, format);
    return createElement(Input, {
      label: label,
      help: help,
      addonBefore: addonBefore,
      addonAfter: addonAfter
    }, createElement(ButtonToolbar, null, createElement(ButtonGroup, null, datePart ? createElement(DropdownButton, {
      noCaret: noCaret,
      dropup: dropup,
      bsStyle: bsStyle,
      title: datetime.format(datePart)
    }, createElement(MenuItem, {
      style: {
        display: "days" === dateView ? "block" : "none"
      },
      header: true
    }, createElement(DatePicker, {
      ref: "day",
      format: format,
      onChange: this.handleDay,
      onClickYear: this.viewYears,
      onClickMonth: this.viewMonths,
      value: value
    })), createElement(MenuItem, {
      style: {
        display: "months" === dateView ? "block" : "none"
      },
      header: true
    }, createElement(MonthPicker, {
      ref: "month",
      format: format,
      onChange: this.handleMonth,
      value: value
    })), createElement(MenuItem, {
      style: {
        display: "years" === dateView ? "block" : "none"
      },
      header: true
    }, createElement(YearPicker, {
      ref: "year",
      format: format,
      onChange: this.handleYear,
      value: value
    }))) : void 0, timePart ? createElement(DropdownButton, {
      noCaret: noCaret,
      dropup: dropup,
      bsStyle: bsStyle,
      title: datetime.format(timePart)
    }, createElement(MenuItem, {
      header: true
    }, createElement(TimePicker, {
      ref: "time",
      format: format,
      display: timePart,
      onChange: this.handleTime,
      value: value
    }))) : void 0)));
  }
});

module.exports = {
  PickerMixin: PickerMixin,
  YearPicker: YearPicker,
  MonthPicker: MonthPicker,
  DatePicker: DatePicker,
  TimePicker: TimePicker,
  DateTime: DateTime
};
